export declare type Variable = string | string[] | [string, string][];
export declare type Variables = {
    [key: string]: Variable;
};
declare const isArray: (variable: string | string[] | [string, string][]) => variable is string[];
declare const isDefined: (variable: string | string[] | [string, string][]) => boolean;
declare const isObject: (variable: string | string[] | [string, string][]) => variable is [string, string][];
declare const isString: (variable: string | string[] | [string, string][]) => variable is string;
declare const normalizeVariables: (variables: {
    [key: string]: any;
}) => {
    [key: string]: string | string[] | [string, string][];
};
export { isArray, isDefined, isObject, isString, normalizeVariables };
